package fr.pandacube.lib.core.chat;

import java.util.Objects;

import fr.pandacube.lib.core.chat.Chat.FormatableChat;
import net.kyori.adventure.text.Component;
import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.TextComponent;

public abstract class ChatStatic {



	public static FormatableChat chatComponent(Component c) {
		return new FormatableChat(c);
	}

	public static FormatableChat chatComponent(BaseComponent c) {
		return new FormatableChat(Chat.toAdventure(c));
	}
	
	public static FormatableChat chat() {
		return chatComponent(Component.empty());
	}
	
	public static FormatableChat chatComponent(BaseComponent[] c) {
		return chatComponent(Chat.toAdventure(c));
	}

	public static FormatableChat text(Object plainText) {
		return chatComponent(Component.text(Objects.toString(plainText)));
	}

	public static FormatableChat legacyText(Object legacyText) {
		return chatComponent(TextComponent.fromLegacyText(Objects.toString(legacyText), null));
	}

	public static FormatableChat infoText(Object plainText) {
		return text(plainText).infoColor();
	}

	public static FormatableChat dataText(Object plainText) {
		return text(plainText).dataColor();
	}

	public static FormatableChat decorationText(Object plainText) {
		return text(plainText).decorationColor();
	}

	public static FormatableChat successText(Object plainText) {
		return text(plainText).successColor();
	}

	public static FormatableChat failureText(Object plainText) {
		return text(plainText).failureColor();
	}

	public static FormatableChat playerNameText(String legacyText) {
		return legacyText(legacyText).white();
	}

	public static FormatableChat translation(String key, Object... with) {
		return chatComponent(Component.translatable(key, Chat.filterObjToComponentLike(with)));
	}

	/** @param key one of the values in {@link net.md_5.bungee.api.chat.Keybinds} */
	public static FormatableChat keybind(String key) {
		return chatComponent(Component.keybind(key));
	}

	public static FormatableChat score(String name, String objective) {
		return chatComponent(Component.score(name, objective));
	}
}
